///////////////////////////////////////////////////////////////////////////////
// auto_value
//
//      (, )
//
//      
//   rsdn.src ()
//
///////////////////////////////////////////////////////////////////////////////
#ifndef AUTOVAL_H
#define AUTOVAL_H


//     
template<class T>
class default_so
{
  public:
    static inline T inc(T& t)
    {
      return ++t;
    }

    static inline T dec(T& t)
    {
      return --t;
    }


};

template< class T, T i = 0, class SO=default_so<T> >
class auto_value
{
  T t_;
public:
  typedef T data_t;
  typedef auto_value& self_t;

  //    -    
  inline auto_value() : t_(i)
  {
  }

  //   1  (   -  )
  template< class V >
  inline auto_value(V v) : t_(v) {}

  //   
  inline const T& data() const { return t_; }
  inline T& data() { return t_; }

  // ,    - 
  //     -       
  //  inline operator T  () const { return t_; }
  inline operator T& ()       { return t_; }

  //  
  template< class V > inline self_t operator =   (V v) { t_ =   v; return *this; }
  template< class V > inline self_t operator +=  (V v) { t_ +=  v; return *this; }
  template< class V > inline self_t operator -=  (V v) { t_ -=  v; return *this; }
  template< class V > inline self_t operator *=  (V v) { t_ *=  v; return *this; }
  template< class V > inline self_t operator /=  (V v) { t_ /=  v; return *this; }
  template< class V > inline self_t operator %=  (V v) { t_ %=  v; return *this; }
  template< class V > inline self_t operator &=  (V v) { t_ &=  v; return *this; }
  template< class V > inline self_t operator |=  (V v) { t_ |=  v; return *this; }
  template< class V > inline self_t operator ^=  (V v) { t_ ^=  v; return *this; }
  template< class V > inline self_t operator <<= (V v) { t_ <<= v; return *this; }
  template< class V > inline self_t operator >>= (V v) { t_ >>= v; return *this; }

  inline T operator ++(){return SO::inc(t_);}
  inline T operator --(){return SO::dec(t_);}

};


#endif

/*
   ??= ,     "myvalue.data() ??= 123"

 :
class MyBigClass
{
  auto_value<bool> m_bEnabled;
  ...

public:
  MyBigClass() {} //     -  
  ...
  bool isEnabled() { return m_bEnabled; } //  false,   0xCDCDCDCD
  void setEnabled(bool b) { m_bEnabled = b; }
  ...
};
 
*/