#ifndef DEVICESTATECALLBACK_H
#define DEVICESTATECALLBACK_H

/// @interface IChangeDeviceStateCallback
///       
///  

class IChangeDeviceStateCallback : public IUnknown
{
public:
	///     
	virtual HRESULT STDMETHODCALLTYPE OnConnect(IDevice* pDevice) = 0;
	
	///     
	virtual HRESULT STDMETHODCALLTYPE OnDisconnect(IDevice* pDevice) = 0;
	
	///  
	virtual HRESULT STDMETHODCALLTYPE OnResetCompleted(IDevice* pDevice) = 0;
	
	///  
	virtual HRESULT STDMETHODCALLTYPE OnProgramCompleted(IDevice* pDevice) = 0;

	///    .      
	virtual HRESULT STDMETHODCALLTYPE OnDestroy(IDevice* pDevice) = 0;
	
	///     
	virtual HRESULT STDMETHODCALLTYPE OnChangeDeviceState(IDevice* pDevice, ULONG nNewState) = 0;
};

/// @interface IChangeDeviceStateRegistry
///       
///    
class IChangeDeviceStateRegistry : public IUnknown
{
public:
	///   
	virtual HRESULT STDMETHODCALLTYPE RegisterStateCallback(IChangeDeviceStateCallback* pCallBack) = 0;
	
	///   
	virtual HRESULT STDMETHODCALLTYPE UnregisterStateCallback(IChangeDeviceStateCallback* pCallBack) = 0;
};

#endif
