#ifndef ANOUT_H
#define ANOUT_H

// {B8A31A21-6125-11d7-9244-00E029288A7F}
extern GUID IID_IAnalogOutput;


class IAnalogOutput : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE LoadPlayDACData(DWORD size, WORD* data) = 0;
	virtual HRESULT STDMETHODCALLTYPE StopPlayDAC() = 0;
	virtual HRESULT STDMETHODCALLTYPE StartPlayDAC(double* freq) = 0;

	virtual HRESULT STDMETHODCALLTYPE GetPlayDACDataMaxCount(DWORD* count) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetPlayDACCodeRange(long* min, long* max) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetPlayDACVoltRange(double* min, double* max) = 0;
	virtual HRESULT STDMETHODCALLTYPE GetPlayDACFreqRange(double* min, double* max) = 0;
	///   
	///  freq -    
	///    mode - 0 -   
	///           1 -   N 
	///    param -   
	/// :freq -     
	virtual HRESULT STDMETHODCALLTYPE StartPlayDACEx(double *freq, DWORD mode, DWORD param) = 0;
	///   
	/// mode - 0 -     0
	///        1 -     
	  virtual HRESULT STDMETHODCALLTYPE StopPlayDACEx(DWORD mode) = 0;


};

#endif