//////////////////////////////////////////////////////////////////////////////
///                                                                           
/// @file IPropStorage.h                                          
///         
/// .           <br>  
/// IProStorageIn, IProStorageOut
///                                                                           
/// : MVC++6.0                                                      
///                                                                           
//////////////////////////////////////////////////////////////////////////////

#ifndef IPROPSTORAGE_H
#define IPROPSTORAGE_H
#include "mebase.h"
#include <string>

namespace mebase{ namespace system{


/// @return 
/// S_OK	-	  <br>
/// S_FALSE -    ,    <br>
/// E_UNKNOWNID -  <br>
/// E_TYPE -  <br>
/// E_OUTOFMEMORY -      



/// @interface IPropStorageIn
///      . <br>
///    .
class IPropStorageIn
{
public:
	virtual MEBRESULT MEBCALLTYPE Read(mebase::ULONG nPropertyID, float* const pfltValue)=0;
	virtual MEBRESULT MEBCALLTYPE Read(mebase::ULONG nPropertyID, mebase::LONG* const plValue)=0;
	virtual MEBRESULT MEBCALLTYPE Read(mebase::ULONG nPropertyID, bool* const pboolValue)=0;		
	virtual MEBRESULT MEBCALLTYPE Read(mebase::ULONG nPropertyID, std::string& strValue)=0;
	virtual MEBRESULT MEBCALLTYPE Read(mebase::ULONG nPropertyID, void* const pValue, mebase::ULONG ulSize, mebase::ULONG& ulWasRead)=0;
	virtual MEBRESULT MEBCALLTYPE Read(mebase::ULONG nPropertyID, IPropStorageIn** const ppSubNode)=0;
};


/// @interface IPropStorageOut
///      . <br>
///    .
class IPropStorageOut
{
public:
	virtual MEBRESULT MEBCALLTYPE Write(mebase::ULONG nPropertyID, const float fltValue)=0;
	virtual MEBRESULT MEBCALLTYPE Write(mebase::ULONG nPropertyID, const mebase::LONG lValue)=0;
	virtual MEBRESULT MEBCALLTYPE Write(mebase::ULONG nPropertyID, const std::string& strValue)=0;
	virtual MEBRESULT MEBCALLTYPE Write(mebase::ULONG nPropertyID, const bool boolValue)=0;				
	virtual MEBRESULT MEBCALLTYPE Write(mebase::ULONG nPropertyID, void* const pValue, mebase::ULONG ulSize)=0;		
	virtual MEBRESULT MEBCALLTYPE Write(ULONG nPropertyID, IPropStorageOut** const ppSubNode)=0;

};

}}
#endif
