//////////////////////////////////////////////////////////////////////////////
///                                                                           
/// @file ISettingsStorage.h                                          
///         
/// .           <br>  
/// ISettingsStorageIn, ISettingsStorageOut
///                                                                           
/// : MVC++6.0                                                      
///                                                                           
//////////////////////////////////////////////////////////////////////////////

#ifndef ISETTINGSSTORAGE_H
#define ISETTINGSSTORAGE_H




/// @interface IPropStorageIn
///      . <br>
///    .
class ISettingsStorageIn
{
public:
	virtual HRESULT STDMETHODCALLTYPE Read(const BSTR bstrPropertyID, float* const pfltValue) = 0;
	virtual HRESULT STDMETHODCALLTYPE Read(const BSTR bstrPropertyID, LONG* const plValue) = 0;
	virtual HRESULT STDMETHODCALLTYPE Read(const BSTR bstrPropertyID, bool* const pboolValue) = 0;		
	virtual HRESULT STDMETHODCALLTYPE Read(const BSTR bstrPropertyID, BSTR* pbstrValue) = 0;
	virtual HRESULT STDMETHODCALLTYPE Read(const BSTR bstrPropertyID, void* const pValue, LONG ulSize, LONG& ulWasRead) = 0;
	virtual HRESULT STDMETHODCALLTYPE Read(const BSTR bstrPropertyID, ISettingsStorageIn** const ppSubNode) = 0;
};


/// @interface IPropStorageOut
///      . <br>
///    .
class ISettingsStorageOut
{
public:
	virtual HRESULT STDMETHODCALLTYPE Write(const BSTR bstrPropertyID, const float fltValue) = 0;
	virtual HRESULT STDMETHODCALLTYPE Write(const BSTR bstrPropertyID, const LONG lValue) = 0;
	virtual HRESULT STDMETHODCALLTYPE Write(const BSTR bstrPropertyID, const BSTR pbstrValue) = 0;
	virtual HRESULT STDMETHODCALLTYPE Write(const BSTR bstrPropertyID, const bool boolValue) = 0;				
	virtual HRESULT STDMETHODCALLTYPE Write(const BSTR bstrPropertyID, void* const pValue, LONG ulSize) = 0;
	virtual HRESULT STDMETHODCALLTYPE Write(const BSTR bstrPropertyID, ISettingsStorageOut** const ppSubNode) = 0;

};

#endif
