#ifndef _VTBL_
#define _VTBL_

// Common commands
#define CMD_GET_OBJECT       38
#define CMD_GET_PROPERTY     9
#define CMD_SET_PROPERTY     10

// ***************  Hardware IFace commands  ***************
// BOOT/Start/Init hardware commands
#define CMD_REPLY             113
#define CMD_INIT_EXT_IFACE    112
#define CMD_TEST_LOAD         7

#define CMD_BIOS_START_UPLOADING 120
#define CMD_BIOS_OUT_BUFFER      121
#define CMD_BIOS_STOP_UPLOADING  122

#define CMD_FLEX_START_UPLOADING  1
#define CMD_FLEX_OUT_BUFFER       2
#define CMD_FLEX_STOP_UPLOADING   3

#define CMD_TEST_IRQ             20
#define CMD_INIT_MDP             21

#define CMD_DEB_TST				49

#define CMD_RESET               125
#define CMD_SAVE_MDP            131
#define CMD_LOAD_MDP            132
#define CMD_DEBUG_CMD1          133
#define CMD_GET_DIAG            23
#define CMD_RESET_TEDS          144
#define CMD_WRITE_TEDS          145
#define CMD_READ_TEDS           146
#define CMD_SET_NWORD           147
#define CMD_READ_GADDR          148

// Resource access commands
#define CMD_READ_BOOT_EEPROM    11
#define CMD_WRITE_BOOT_EEPROM   12
#define CMD_LOCK_BOOT_EEPROM    13
#define CMD_ERASE_BOOT_EEPROM   14
#define CMD_READ_CTRLREG_BOOT_EEPROM     28
#define CMD_WRITE_CTRLREG_BOOT_EEPROM    29

#define CMD_BAUD_RATE           130

#define CMD_READDM           15
#define CMD_WRITEDM          16
#define CMD_READPM           17
#define CMD_WRITEPM          18
#define CMD_READIO           114
#define CMD_WRITEIO          115
#define CMD_MC_READDM        116
#define CMD_MC_WRITEDM       117
#define CMD_MC_READPM        118
#define CMD_MC_WRITEPM       119
#define CMD_MC_READ_CFG      123
#define CMD_MC_WRITE_CFG     124

#define CMD_READ_STORAGE     126
#define CMD_WRITE_STORAGE    127
#define CMD_TEST_MCDM        128

#define CMD_MASTER_IN_TEST   129

#define CMD_RAM_BOOT         19

// Time/Synchro/Trigger commands
#define CMD_PAUSE_TIMER      24
#define CMD_RESTORE_TIMER    25
#define CMD_ENA_EXT_ADC      26
#define CMD_RESET_TRIGGER    42
#define CMD_CONFIG_TRIGGER   43
#define CMD_GET_AIN_START    44
#define CMD_MIGALKA_CTRL     44
#define CMD_SEND_CONTROL_WORD   45
#define CMD_TRIGGER_START       96
#define CMD_APPLY_CHANMASK      97

// Acquisition device commands
#define CMD_INIT_DEVICE         92

#define CMD_START_SCAN_MAIN      4 //   (   ) (  ,   )
#define CMD_STOP_SCAN_MAIN       5 //  
#define CMD_RESET_SCAN_MAIN      6 //       . 
                                   //       ..     (SetProperty).
#define CMD_PROGRAMMING         22 //        .

//    DSP-  (DSP- ..  , - , ,    ..)
#define CMD_GET_CHANNEL         30 //  HANDLE DSP-    

#define CMD_SET_PROP_CHAN       31 //   DSP-  
#define CMD_GET_PROP_CHAN       32 //   DSP-    
#define CMD_PROGRAM_CHAN        33 //  ,   DSP- 
#define CMD_RESET_CHAN          34 //   ( DSP-   )
#define CMD_PRESET_CHAN         35 //     
#define CMD_START_CHAN          36 //   
#define CMD_STOP_CHAN           37 //   


#define CMD_OUT_START_FLAG       8
#define CMD_ASSIGN_CHAN CMD_PROGRAM_CHAN


#define CMD_SEND_2_CONT_REG CMD_PROGRAMMING

#define CMD_NEW_CONFIG_WORD  23
#define CMD_RESET_ADC        27

#define CMD_MAC_CONFIG       39
#define CMD_RESET_CHAN_LIST  40
#define CMD_SET_CHAN_LIST    41
#define CMD_DIS_FLOOR_SYNC   44
#define CMD_SET_GRID         50
#define CMD_SET_FREQ         51
#define CMD_SET_SYNTHEZ      52


#define CMD_SEND_BALANCE     53
#define CMD_LATCH_CAL_DAC       56
#define CMD_SEND_2_CALIBR_DAC   57
#define CMD_CONFIG_RAW       58
#define CMD_CONFIG_DBL       59
#define CMD_CONFIG_MIX       60
#define CMD_CONFIG_TIMING    61
#define CMD_CONFIG_IRQPC     62
#define CMD_GET_PXI_SLOT     62
#define CMD_GET_FINAL_FLAG   63
#define CMD_CONFIG_MARK      64
#define CMD_CONFIG_AOUT      66
#define CMD_GET_AOUT_DESC    67

#define CMD_DAC_REPLY        68
#define CMD_STOP_DAC_REPLY   69
#define CMD_D_IN             70
#define CMD_D_OUT            71
#define CMD_SEND_CALIBR      72
#define CMD_INIT_DAC_TASK    73
#define CMD_START_DAC_TASK   74
#define CMD_STOP_DAC_TASK    75
#define CMD_ASSIGN_STAT      76
#define CMD_CONFIG_HARM      77
#define CMD_GET_STAT_DESC    78
#define CMD_GET_HARM_DESC    79
#define CMD_ASSIGN_TAR       80
#define CMD_SET_K_CALIBR     81
#define CMD_SET_CALIBR_DAC   82
#define CMD_CONFIG_STAT      83
#define CMD_SET_K_BALANCE    84
#define CMD_SET_ZR_OFFSET    85
#define CMD_GET_ZR_OFFSET    86
#define CMD_GET_K_CALIBR     87
#define CMD_ASSIGN_DECIM     88
#define CMD_ASSIGN_FREQ_DIN     89

#define CMD_START_AOUT_TASK     93
#define CMD_STOP_AOUT_TASK      94
#define CMD_PRESET_OTHER        95
#define CMD_SET_HOST_PHYS_ADDR  98
#define CMD_MT_ENABLE           99

/* External Amplifyer */
#define CMD_LPF_918             100
#define CMD_KU_918              101
#define CMD_SEND_918            102
#define CMD_RDTSC               103
#define CMD_SEND_908            104
#define CMD_READ_OVERLOAD_918   105
#define CMD_READ_OVERLOAD_908   106
#define CMD_GET_EEPROM_908      107
#define CMD_SET_EEPROM_908      108

#define CMD_SPI_CMD             109

#define CMD_SET_RTSI_MASTER     110
#define CMD_GET_RTSI_STATE      111
#define CMD_IO_CTRL             134
#define CMD_GET_SEV             135
#define CMD_DEV_IO              136

//TMI Commands
#define CMD_SET_PARAMS			143
#define CMD_SET_TASK			45
#define CMD_SET_IMASK			46
#define CMD_PRG_AD6620			47
#define CMD_PRG_BLT				48
#define CMD_DEB_TST				49
#define CMD_SET_FL_TRNS			54
#define CMD_SET_PARAM			90
#define CMD_GET_PARAM			91
#define CMD_ZERO_OV				55
#define CMD_SYNC_OV				141
#define CMD_READ_ARU			142
// ME320
#define CMD_READ_MEREG             134
#define CMD_START_CYCLE_WRITE_CTRL_MEREG 135
#define CMD_STOP_CYCLE_WRITE_CTRL_MEREG  136
//
#define CMD_MC_READ_REG                  137
#define CMD_MC_WRITE_REG                 138
// ME-320
#define CMD_LOAD_CTRL_MEREG 	139
#define CMD_START_CTRL_MEREG 	140
// ME-330
#define CMD_START_CTRL_ME330REG 141

/* Old */
#define SEND_908            104
#define READ_OVERLOAD_918   105
#define READ_OVERLOAD_908   106
#define GET_EEPROM_908      107
#define SET_EEPROM_908      108

// MC-012
#define CMD_DISPLAY 58
#define CMD_OUT_DIGIT_402_MC012 100
#define CMD_SET_LEVEL_201 101
#define CMD_OUT_DIGIT_MASK_40X_MC012 102
#define CMD_ENABLE_USB_STREAM 150

#define CMD_TEDS_MODE_ON 151
#define CMD_TEDS_MODE_OFF 152

#define CMD_NO_DSP_MODULES 154

#define LAST_VTBL_MEMBER    	154
#define VTBL_LEN (LAST_VTBL_MEMBER+1)

#endif // _VTBL_
//