#ifndef DBL_COMPARE_H
#define DBL_COMPARE_H
#include <float.h>
#include <math.h>
#include <limits>


template <class T>
inline bool fp_eq(const T a, const T b, const T eps = std::numeric_limits<T>::epsilon())
{
	return fabs(a - b) < eps;
}


inline bool dbl_eq(double a, double b)
{
	return fabs(a - b) < DBL_EPSILON;
}

inline bool float_eq(float a, float b)
{
	return fabs(a - b) < FLT_EPSILON;
}


inline bool dbl_eq_null(double v)
{
	return fabs(v) < DBL_EPSILON;
}

inline bool is_not_number(double v)
{
	__asm {
		finit
	};
	return v == std::numeric_limits<double>::infinity() ||
			v == std::numeric_limits<double>::quiet_NaN() ||
			v == std::numeric_limits<double>::signaling_NaN();
	
}

#endif

