#ifndef XDEVTREEITEM_H
#define XDEVTREEITEM_H

typedef enum {
	DVT_ROOT, 
	DVT_HOST, 
	DVT_MODULE,
	DVT_BUS
} DEVICETYPE;



class XDEVTREEITEM
{
public:
	virtual int GetApiId() const = 0;

	virtual const DEVICETYPE GetType() const = 0;
	
	///       
	virtual const ULONG GetSubDevicesLimit() const = 0;

	virtual const ULONG GetSubDevicesCount() const = 0;

	virtual bool EditDeviceSettings(HWND h) = 0;

	virtual const void* GetDeviceRaw() const = 0;

	virtual void Destroy() = 0;

	virtual bool ForceResetDevice() = 0;
};

#endif