#ifndef IBUSLINK_H
#define IBUSLINK_H
///////////////////////////////////////////////////////////////////////////////
//! 

#include "mebase.h"
#include "mestring.h"
#include "metypes.h"
#include "IDeviceInfo.h"
#include "IDevice.h"

#include "ISearhDevicesCallback.h"


namespace mebius_daq{
//using namespace mebase;

class IDevice;
class ISearhDevicesCallback;
class IPipeOut;
class IDeviceInfo;

using mebase::system::mestring;

/// @interface IBusLink
///     
/// 
///        
///    ,     
///  
class IBusLink : public IObject
{
public:

	virtual MEBRESULT MEBCALLTYPE Connect() = 0; 

	virtual MEBRESULT MEBCALLTYPE Disconnect() = 0;

	virtual MEBRESULT MEBCALLTYPE IoControl(
		mebase::ULONG nIoControlCode,
		const void* pInBuffer,
		mebase::ULONG nInBufferSize,
		void* pOutBuffer,
		mebase::ULONG nOutBufferSize,
		mebase::ULONG* pnBytesReturned,
		void* reserved = 0
	) = 0;

	virtual MEBRESULT MEBCALLTYPE IoControlEx(
		mebase::TASKID nReceiverId,  //< id   
		mebase::ULONG nIoControlCode,
		const void* pInBuffer,
		mebase::ULONG nInBufferSize,
		void* pOutBuffer,
		mebase::ULONG nOutBufferSize,
		mebase::ULONG* pnBytesReturned,
		void* reserved = 0
		) = 0;


		
//     
	
	virtual MEBRESULT MEBCALLTYPE LockBus() = 0;
	virtual MEBRESULT MEBCALLTYPE UnlockBus() = 0;	
	
	
	virtual MEBRESULT MEBCALLTYPE GetBusRef(IBus** ppBus) = 0;

};
}
#endif
	
