#ifndef IMDRTCREGISTRY_H
#define IMDRTCREGISTRY_H


#include "mebase.h"
#include "IBusDriver.h"
#include "IObject.h"
#include "IDeviceDriver.h"
#include "mestring.h"

//using namespace mebase;
namespace mebius_daq{

using mebase::MEBRESULT;

class IDeviceDriver;
class IBusDriver;

/// @interface IMebiusDaqRegistry
class IMebiusDaqRegistry
{
public:
	virtual MEBRESULT MEBCALLTYPE RegisterBusDriver(mebase::ULONG id, IBusDriver* pDriver) = 0;
	virtual MEBRESULT MEBCALLTYPE RegisterDeviceDriver(mebase::ULONG id, IDeviceDriver* pDriver) = 0;
	virtual MEBRESULT MEBCALLTYPE RegisterTopLevelBus(mebase::system::mestring& bus_name, mebase::ULONG id) = 0;

	
	///      .<br>
	///  MEB_S_OK  MEB_S_FALSE
	virtual MEBRESULT MEBCALLTYPE CheckBus(mebase::ULONG id) const = 0;

};
typedef IMebiusDaqRegistry IDevApiRegistry;
}

#endif
