#ifndef IDEVICEDRIVER_H
#define IDEVICEDRIVER_H
#include "mebase.h"
#include "IDevApi.h"
#include "IDevApiRegistry.h"
#include "IObject.h"


namespace mebius_daq{
//using namespace mebase;
using mebase::MEBRESULT;
using mebase::DEVICECLASSID;
using mebase::BUSID;


class IMebiusDaq;
class XDevice;
class IDeviceInfo;

/// @interface IDeviceDriver
///       
class IDeviceDriver : public IObject
{
public:

	virtual MEBRESULT MEBCALLTYPE Init(IMebiusDaq* pCore) = 0;
	virtual MEBRESULT MEBCALLTYPE Uninit() = 0;	
	virtual MEBRESULT MEBCALLTYPE CreateDevice(XDevice** pDevice, IDeviceInfo* pDevInfo) = 0;
	virtual MEBRESULT MEBCALLTYPE DestroyDevice(XDevice* pDevice) = 0;
	virtual MEBRESULT MEBCALLTYPE GetDeviceClassID(DEVICECLASSID* pID) const = 0;
	///       
	virtual MEBRESULT MEBCALLTYPE GetDeviceBusID(BUSID* pID) const = 0;

};

}

#endif
