#ifndef MRPROPERTYIDS_H
#define MRPROPERTYIDS_H

#include "MebiusDAQ/Iface/PropIdBase.h"

namespace mebius_daq{

const mebase::ULONG MEPROP_MR405_BASE = 1;
const mebase::ULONG MEPROP_MR045_BASE = 2;
const mebase::ULONG MEPROP_MR114_BASE = 3;
const mebase::ULONG MEPROP_MR451_BASE = 4;
const mebase::ULONG MEPROP_MR406_BASE = 5;
const mebase::ULONG MEPROP_MR401_BASE = 6;
const mebase::ULONG MEPROP_MR2503_BASE = 7;
const mebase::ULONG MEPROP_MR820_BASE = 8;
const mebase::ULONG MEPROP_MR2507_BASE = 9;
const mebase::ULONG MEPROP_MR2355_BASE = 0xA;
const mebase::ULONG MEPROP_MR2083_BASE = 0xB;
const mebase::ULONG MEPROP_MR718_BASE = 0xC;
const mebase::ULONG MEPROP_ME105_BASE = 0xD;
const mebase::ULONG MEPROP_MR202_BASE = 0xE;
const mebase::ULONG MEPROP_MR302_BASE = 0xF;
const mebase::ULONG MEPROP_MR227_BASE = 0x10;
const mebase::ULONG MEPROP_ME824_BASE = 0x11;
const mebase::ULONG MEPROP_ME330_BASE = 0x12;

const mebase::ULONG MEDEVICETYPE_MR405			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0001);
const mebase::ULONG MEDEVICETYPE_MR045			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0002);
const mebase::ULONG MEDEVICETYPE_MR114			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0003);
const mebase::ULONG MEDEVICETYPE_MRCRATE		= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0004);
const mebase::ULONG MEDEVICETYPE_MR451			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0005);
const mebase::ULONG MEDEVICETYPE_MR406			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0006);
const mebase::ULONG MEDEVICETYPE_MR401			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0007);
const mebase::ULONG MEDEVICETYPE_MR2503			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0008);
const mebase::ULONG MEDEVICETYPE_MR820			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0009);
const mebase::ULONG MEDEVICETYPE_MR2355			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x000A);
const mebase::ULONG MEDEVICETYPE_MR2083			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x000B);
const mebase::ULONG MEDEVICETYPE_MR718			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x000C);
const mebase::ULONG MEDEVICETYPE_ME808			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x000D);
const mebase::ULONG MEDEVICETYPE_MOD_ME415      = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x000E);
const mebase::ULONG MEDEVICETYPE_MR404          = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x000F);
const mebase::ULONG MEDEVICETYPE_MR114V4		= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0010);
const mebase::ULONG MEDEVICETYPE_MR402			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0011);
const mebase::ULONG MEDEVICETYPE_MR114V5		= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0012);
const mebase::ULONG MEDEVICETYPE_MIC224         = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0013);
const mebase::ULONG MEDEVICETYPE_MIC236         = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0014);
const mebase::ULONG MEDEVICETYPE_ME105			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0015);
const mebase::ULONG MEDEVICETYPE_ME819			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0016);
const mebase::ULONG MEDEVICETYPE_ME825			= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0017);
const mebase::ULONG MEDEVICETYPE_MR114V4C1		= MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0018);
const mebase::ULONG MEDEVICETYPE_MR202          = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0019);
const mebase::ULONG MEDEVICETYPE_MR629          = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x001A);
const mebase::ULONG MEDEVICETYPE_MR302          = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x001B);
const mebase::ULONG MEDEVICETYPE_MR227K1        = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x001C);
const mebase::ULONG MEDEVICETYPE_MR227R6        = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x001D);
const mebase::ULONG MEDEVICETYPE_MR452          = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x001E);
const mebase::ULONG MEDEVICETYPE_ME824          = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x001F);
const mebase::ULONG MEDEVICETYPE_MIC850         = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0020);
const mebase::ULONG MEDEVICETYPE_ME330          = MAKE_DEVICE_TYPEID(DEV_CLASSID_MR, 0x0021);


typedef enum {
	// ME-105, ME-819, ME-825
	MEPROP_ME105_MAJORITYPERIOD               = MAKE_PROPID(MEPROP_ME105_BASE, 0, 0),
	MEPROP_ME819_MAJORITYPERIOD               = MAKE_PROPID(MEPROP_ME105_BASE, 0, 1),
	MEPROP_ME825_MAJORITYPERIOD               = MAKE_PROPID(MEPROP_ME105_BASE, 0, 2),

	///    mi1500
	MEPROP_MR2507_PROGRAM_CONTROL             = MAKE_PROPID(MEPROP_MR2507_BASE, 0, 0),
	MEPROP_MR2507_VIRTUAL_SLOT_ENABLED        = MAKE_PROPID(MEPROP_MR2507_BASE, 0, 1),
	MEPROP_MR2507_VIRTUAL_SLOT_NUMBER         = MAKE_PROPID(MEPROP_MR2507_BASE, 0, 2)
}MR_PROPIDS;

}

#endif

