#ifndef MEERRORS_H
#define MEERRORS_H
///////////////////////////////////////////////////////////////////////////////
//!   
///////////////////////////////////////////////////////////////////////////////
//! Project: mebius 
//!  
//! @version 1.0 - 
///////////////////////////////////////////////////////////////////////////////
namespace mebase{ 


/// Facility  MEBRESULT   
#define FACILITY_MEBIUS 0xBAC


#define MAKE_MEBRESULT(sev, fac, code) \
    ((MEBRESULT) (((ULONG)(sev)<<31) | ((ULONG)(fac)<<16) | ((ULONG)(code))) )


#define MEB_SUCCEEDED(Status) ((mebase::MEBRESULT)(Status) >= 0)


#define MEB_FAILED(Status) ((mebase::MEBRESULT)(Status)<0)


///  
const MEBRESULT S_MEB_OK =  0;
const MEBRESULT S_MEB_TRUE =  S_MEB_OK;

///     false
const MEBRESULT S_MEB_FALSE =  1;

///  
const MEBRESULT E_MEB_FAIL  = -1;

///    
const MEBRESULT E_MEB_INVALIDARG     = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2000);

///   
const MEBRESULT E_MEB_NOTIMPL        = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2001);

///   
const MEBRESULT E_MEB_POINTER        = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2002);

///  
const MEBRESULT E_MEB_CONNECTION     = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2003);

///   
const MEBRESULT E_MEB_NOTFOUND       = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2004);

///   
const MEBRESULT E_MEB_UNEXPECTED     = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2005);

///     
const MEBRESULT E_MEB_UNINITIALIZED  = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2006);

///  
const MEBRESULT E_MEB_CANT_REGISTER  = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2007);

///   
const MEBRESULT E_MEB_OUT_OF_RANGE   = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2008);

///   
const MEBRESULT E_MEB_TIMEOUT        = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2009);

///  
const MEBRESULT E_MEB_INVALID_FORMAT = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2010);

///   
const MEBRESULT E_MEB_ALREADY_EXIST  = MAKE_MEBRESULT(1,FACILITY_MEBIUS,2011);



}

#endif
