#ifndef IDATAACCESS_H
#define IDATAACCESS_H


// {71DE6EAE-1516-4fe7-80AD-2FFEE1D7D4C1}
extern const GUID IID_IDataAccess;


///   
enum DATA_LAYOUT_TYPE 
{
	DLT_PLAIN, ///<   (, ,    )
	DLT_FRAMES
};

enum DATA_READ_OPTION_FLAGS
{
	DROPTF_TIME_AS_UTS = 0x00001, 
};

// {275A9AB0-8207-413f-AB53-C2C7F97FF7F9}
extern const GUID IID_IDataAccessIndex;

enum {
	DACCESS_SEEK_BEGIN,
	DACCESS_SEEK_CUR,
	DACCESS_SEEK_NEW_DATA
};

class IDataAccess;
class IDataAccessIndex : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE Rewind(LONGLONG nPos, ULONG nParam) = 0;
	
};

// {FC20643C-9644-453c-8D14-5AD460990541}
extern const GUID IID_IDataAccessEvents;

class IDataAccessEvents : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE OnDataReady(IDataAccess* pDataAccess) = 0;
};

class IDataAccess : public IUnknown
{
public:
	///    
	///          
	virtual HRESULT STDMETHODCALLTYPE Open(IDataAccessIndex** ppIndex, IDataAccessEvents* pDataAccessEvents) = 0;

	///    	
	virtual HRESULT STDMETHODCALLTYPE Close(IDataAccessIndex* pIndex) = 0;
	
	///  
	/// @param pBufferX -         0
	/// 
	virtual HRESULT STDMETHODCALLTYPE ReadData(
			IDataAccessIndex* pIndex, 
			float* pBufferY, 
			float* pBufferX,
			ULONGLONG nBufferLen, 
			ULONG nParamFlags
		) = 0;
	

	///     
	/// @param pBufferX -         0
	/// 
	virtual HRESULT STDMETHODCALLTYPE ReadDataEx(
			IDataAccessIndex* pIndex, 
			void* pBufferY, 
			VARTYPE vtY,
			void* pBufferX,
			VARTYPE vtX,
			ULONGLONG nBufferLen, 
			ULONG nParamFlags
		) = 0;


	///      
	virtual HRESULT STDMETHODCALLTYPE GetDataSize(const IDataAccessIndex* pIndex, ULONGLONG* ppnSize) const = 0;
};

#endif