#ifndef ICALIBR_H
#define ICALIBR_H

#include "itag.h"

enum{
  CLBPROP_FLAGS
};

typedef enum enumCLBFLAGS{
  CF_DEVICECALIBR = 0x0001,
  CF_TAGCALIBR    = 0x0002,
  CF_STANDARTMODE = 0x0004,
  CF_ADVANCEDMODE = 0x0008
}CLBFLAGS;

class ICalibrator: public IUnknown
{
  public:
    virtual HRESULT STDMETHODCALLTYPE Create()PURE;
    virtual HRESULT STDMETHODCALLTYPE Run()PURE;
    
    virtual HRESULT STDMETHODCALLTYPE AddTag(ITag* a_piTag)PURE;
    virtual ULONG   STDMETHODCALLTYPE Save(LPVOID a_lpvStream)PURE;
    virtual ULONG   STDMETHODCALLTYPE Load(LPVOID a_lpvStream)PURE;

    virtual HRESULT STDMETHODCALLTYPE GetProperty(DWORD a_dwPropID, VARIANT& a_varProp)PURE;
    virtual HRESULT STDMETHODCALLTYPE SetProperty(DWORD a_dwPropID, VARIANT a_varProp)PURE;

    //    
    virtual bool		STDMETHODCALLTYPE Notify(DWORD a_dwCommand, DWORD a_dwData=0)PURE;


};

#endif
