#ifndef IPRCMSGR_H
#define IPRCMSGR_H



typedef enum {
	PMO_PROGRESSBAR     = 0x0001,
	PMO_EXTERNALIMAGE   = 0x0002,
	PMO_FINALIZENODELAY = 0x0004,
	PMO_STARTUPMODE     = 0x0008,
}PMOPTIONS;

// {76154E58-87AA-480d-BED0-C09F40FD31F6}
static const GUID IID_IProgressMessager = 
{ 0x76154e58, 0x87aa, 0x480d, { 0xbe, 0xd0, 0xc0, 0x9f, 0x40, 0xfd, 0x31, 0xf6 } };


class IProgressMessager: public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE wm_Show(const char* a_pchTitle, const char* a_pchMessage, DWORD a_dwPictureID, DWORD a_dwOptions = 0, HWND hTopWnd=0) = 0;
	virtual HRESULT STDMETHODCALLTYPE wm_Hide() = 0;
	virtual HRESULT STDMETHODCALLTYPE wm_SetMessageText(const char* a_pchMessage) = 0;
	virtual HRESULT STDMETHODCALLTYPE wm_SetProgressPos(int a_nPos) = 0;
	virtual HRESULT STDMETHODCALLTYPE wm_FinalizeProgress() = 0;
	virtual HRESULT STDMETHODCALLTYPE wm_GetCancelState(VARIANT_BOOL* a_pfCanceled) = 0;
	virtual HRESULT STDMETHODCALLTYPE wm_SetMessageTextFontSize(int a_nPoint) = 0;	

};
#endif