//! @copyright ()  , 1996 - 2012. All rights reserved.
//! <http://www.nppmera.ru>
//!
//! @file itag.h
//!
//! @date 2001-2012
//!
//! @author  ..
//! @brief  Recorder.       
//! @details    ITag.     
//!
//! @version 3.0


#ifndef ITAG_H
#define ITAG_H

#include "itypes.h"
#include "datastat.h"
#include "iSignal.h"
#include "itaggrp.h"


typedef __int64 TAGID;

// {E8DAE361-53EE-11d7-9244-00E029288A7F}
static const GUID IID_ITag = 
	{ 0xe8dae361, 0x53ee, 0x11d7, { 0x92, 0x44, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };


///     
///     @ref ITag::GetLinkState
enum LINKSTATE
{
	LS_HARDWARE, ///<    
	LS_VIRTUAL,  ///<         
	LS_LOST,     ///<     ,   
	LS_PIPE      ///<       ,  
};

///    @ref ITag::Notify
enum TAGNOTIFY 
{
	TN_UPDATETAGTX,               ///<  
	TN_ERASETAGTX,                ///<    
	TN_SETVECTORDELTA,            ///<  dX   ,   VirtualTags
	TN_WRITETAGTXINFOFILE,        ///<    ()

	TN_PREPARE_TARGETS,           ///<   dwParams==MASK ()
	TN_FINISH_TARGETS,            ///<    dwParams==MASK ()
	TN_STARTREC,                  ///<      ()
	TN_STOPREC,                   ///<     ()
	TN_ERASEDEVTX,                ///<     
	TN_TRYTORELINK,               ///<       
	TN_UPDATEDEVTAREDB,           ///<      
	TN_ZEROBALANCE,               ///<     
	TN_EDITOWNER,                 ///<     
	TN_RESETOWNER,                ///<     
	TN_UPDATEDEVCHAN,             ///<     
	TN_DOWNLOAD_TARE_FROM_DEVICE, ///<     
	TN_UPLOAD_TARE_TO_DEVICE,     ///<     
	TN_LOAD_DEV_TARE_FROM_DB,     ///<     
	TN_UNLINKDEVCHAN,             ///<    
	TN_PROCESSLOST,               ///<         
	TN_RECALCRANGES,              ///<  
	TN_UPDATEALARMS,              ///<    ()
	TN_PUTPORTIONINFO,            ///<     
	                              ///< struct @ref PORTIONINFO
	TN_WRITEALARMSINFO,           ///<     ()
	TN_UPDATECHANID,              ///<  ChanID   
	TN_UPDATEUNITS,               ///<   
	TN_RESET_DATA_BUF,            ///<    , 
	                              ///<        PushValue
	TN_DISABLE_TARGETS,           ///<     dwParams==MASK ()
	TN_FLUSH_TARGETS,             ///<      dwParams==MASK ()
	TN_ON_STOP_TARGETS            ///<      


};

///     /   ITag::GetProperty/ITag::SetProperty
enum TAGPROPERTYID
{
	TAGPROP_BUFFSIZE,                  ///<   FIFO                            [out]
	TAGPROP_ESTIMATOR,                 ///<                              [in, out]
	TAGPROP_ESTIMATE,                  ///<                                        [out]
	TAGPROP_DATATYPE,                  ///<                                     [in, out]
	                                   ///<     3.1.1 
	                                   ///< SetProperty:
	                                   ///< vt = VT_UI4, ulVal = VT_XXX   
	                                   ///<    vt = VT_XXX
	                                   ///<   
	                                   ///< GetProperty  Set 
	                                   ///<    
	TAGPROP_HARDWAREADRESS,            ///<                         [out]
	TAGPROP_TYPE,                      ///<                               [in, out]
	TAGPROP_DEVCHANID,                 ///<                [in, out]  
	TAGPROP_MINVALUE,                  ///<                           [in, out]
	TAGPROP_MAXVALUE,                  ///<                          [in, out]
	TAGPROP_TARE,                      ///<                    [in, out]
	TAGPROP_OWNER,                     ///<  ( IRecorderPlugin)         [out]
	TAGPROP_MODULE,                    ///<  (HardLink)                            [out]
	TAGPROP_OWNDEVICE=TAGPROP_MODULE,  ///<  (HardLink)                            [out]
	TAGPROP_DEVSIGNALTYPE,             ///<     , ..         [in, out]
	TAGPROP_UNITS,                     ///<                              [in, out]
	TAGPROP_RECENABLED,                ///<                [out]
	TAGPROP_DESCRIBE,                  ///<                                      [in, out]
	TAGPROP_MODULENAME,                ///<                                     [out]  
	TAGPROP_MODULESERNUM,              ///<                           [out]
	TAGPROP_DEVTARE,                   ///< .        [in, out]
	TAGPROP_MINUSERVALUE,              ///<          [in, out]
	TAGPROP_MAXUSERVALUE,              ///<         [in, out]
	TAGPROP_AUTORANGE,                 ///<                                              [in, out]
	TAGPROP_IRECORDER,                 ///<   IRecorder        [out]           
	TAGPROP_LEVELEXCEED,               ///<                              [in, out]
	TAGPROP_VIEWRANGE,                 ///<                           [in]
	TAGPROP_MAXXVIEWRANGE,             ///<      X   [in, out]    
	TAGPROP_MODCHANNUMBER,             ///<                            [out]    
	TAGPROP_DEFAULTESTIMATOR,          ///<                   [in, out]
	                                   ///<    
	TAGPROP_DEVCHAN,                   ///<                       [out]
	TAGPROP_DEVCHANINFO,               ///<       [out]
	TAGPROP_FREQCOUNT,                 ///<         [out]
	TAGPROP_HASTARE,                   ///<                               [out]       VT_BOOL
	TAGPROP_CLB_PROPS_BIN_SIZE,        ///<      
	TAGPROP_AVERAGEESTIMATE,           ///<                               [in, out]   VT_BOOL
	TAGPROP_AVERAGEESTIMATEALPHA,      ///<                          [in, out]   VT_R8
	TAGPROP_ESTIMATEPORTION,           ///<              [in, out]   VT_I4
	TAGPROP_ENABLEFREQCORRECTION,      ///<     VT        [in]        VT_BOOL
	TAGPROP_STOPLEVELEXCEED,           ///<                        [in, out]   VT_BOOL
	TAGPROP_TARE_ENABLED,              ///<               [in]        VT_BOOL
	TAGPROP_ATTRIB_UNEDITABLE,         ///<  :                 [in, out] VT_BOOL
	                                   ///< (   rc  )
	TAGPROP_ATTRIB_HIDEN,              ///<  :                         [in, out] VT_BOOL
	                                   ///< (    rc,     )
	TAGPROP_SIGNAL_START_TIME,         ///<         [out] VT_R8
	TAGPROP_UTS_CHAN_NAME,             ///<    [in ( ), out] VT_BSTR
	TAGPROP_FLASH_TARE_INFO,           ///<        [out] VT_BSTR
	TAGPROP_IS_UTS_CHANNEL,            ///<    [out] VT_BOOL
	TAGPROP_RESERVED_SPACE_SIZE,       ///<       	[out] VT_UI4
	TAGPROP_STATUS_WORD,               ///<    [out] VT_UI4
	TAGPROP_TARES_COUNT,               ///<   [out] VT_I4
	TAGPROP_HWCH_PROPS,                ///<      [out] VT_UNK
	TAGPROP_ALARMS_STATE_W,            ///<    [out] VT_UI4
	TAGPROP_ALARMS_COLOR,              ///<    [out] VT_UI4
	TAGPROP_ALARMS_TIMESTAMP,          ///<     [out] VT_DATE
	                                   ///<  
	TAGPROP_DEV_CHAN_TYPE,             ///<   ,  devapi::const.h [out] VT_I4
	TAGPROP_AUTOUNITS,                 ///<    	[in,out] VT_BOOL {ver:3.0.4.40}
	TAGPROP_CHAR_TP_WORD,              ///<   .mera  "CharTp"    [in,out] VT_UI4   {ver:3.0.4.52}
	TAGPROP_WRITE_CODES,               ///<     [out] VT_BOOL

	TAGPROP_DESTROYED_FLAG,            ///<  ,                    [out] VT_BOOL
	                                   ///<      ,   , 
	TAGPROP_CAN_ZBALANCE,              ///<     [out] VT_BOOL
	TAGPROP_PERMANENT_ID,              ///<    ,  "ChanId" [out] VT_BSTR
	TAGPROP_UNITS_CODE,                ///< meUnits    [out] VT_UI8
	EXTENDED_TAGPROP_BASE              = 0x8000,
	TAGPROPEX_AVL_FREQ,                ///<  
	TAGPROPEX_CLB_PROPS_BIN,           ///<     
	TAGPROPEX_TEXTCOLOR,               ///<              [in,out]   VT_UI4
	TAGPROPEX_PH_FINISH_TIME,          ///<    /     [in]  VT_R8
	TAGPROPEX_PH_START_TIME,           ///<    [in]  VT_R8
	TAGPROPEX_TARE_BY_INDEX,           ///<    [in,out] VT_UNK
	TAGPROPEX_TARE_ST_BY_INDEX,        ///<    [in,out] VT_UI4
	TAGPROPEX_ESTIMATE_PRECISION       ///<      (  ).
	                                   ///<  0,    " "
	                                   ///<   lSubPropertyIndex    [in,out] VT_I4

};


/// TAGPROPEX_TARE_ST_BY_INDEX
enum TARESTATUS
{
	TARESTAT_NULL      = 0x0000,
	TARESTAT_ENABLED   = 0x0001
};

///    
enum SCALARESTIMATEINFOCODE
{
	SEIC_NAME,      ///< 
	SEIC_DESC,      ///< 
	SEIC_SHORTNAME  ///<  
};


//  
enum TAGTYPE
{
	TTAG_VECTOR     = 0x0001,      ///<  
	TTAG_SCALAR     = 0x0002,      ///<  
	TTAG_IRREGULAR  = 0x0004,      ///<     
	                               ///<    
	TTAG_OUTPUT     = 0x0100,      ///<   
	TTAG_INPUT      = 0x0200,      ///<  ,    ...
	TTAG_PIPE       = 0x0400       ///< 

};


enum ESTIMATORTYPE
{  //  
	ESTIMATOR_EMPTY = 0x0000000UL,   ///<  
	ESTIMATOR_MEAN  = 0x0000001UL,   ///< MO
	ESTIMATOR_RMSV  = 0x0000002UL,   ///< 
	ESTIMATOR_RMSD  = 0x0000004UL,   ///< 
	ESTIMATOR_PEAK  = 0x0000008UL,   ///< 
	ESTIMATOR_P2P   = 0x0000010UL,   ///< -
	ESTIMATOR_MIN   = 0x0000020UL,   ///< 
	ESTIMATOR_MAX   = 0x0000040UL,   ///< 
	ESTIMATOR_LAST,
	ESTIMATOR_DEFAULT=0xFFFFFFFFUL

};

typedef struct tagPORTIONINFO
{
	ULONG  index;
	double time;
}PORTIONINFO, *PPORTIONINFO;

 ///    
enum TAGSTATUS
{
	TGST_EMPTY               = 0x000000UL,   ///<  
	TGST_LOST_SOURCE         = 0x00000001UL, ///<     
	TGST_WALARM_WAS_SIGNALED = 0x00000002UL, ///<   
	                                         ///<     ,   
	                                         ///<       DATAST_ALARM_XXX
	                                         ///< Set/GetScalarStatus
	TGST_AALARM_WAS_SIGNALED = 0x00000004UL  ///<   
};



class ITagsGroup;

/// @interface ITag
/// ,  ,     .
///     @ref ITagsGroup,
///   @ref TAGPROP_DESCRIBE,   @ref TAGPROP_UNITS.
///      @ref IAlarmsControl, @ref IAlarm
/// 
class ITag : public IUnknown
{
	public:
		///    
		virtual LINKSTATE   STDMETHODCALLTYPE GetLinkState() const = 0;
		///    
		virtual bool        STDMETHODCALLTYPE Edit() = 0;

		///  
		virtual bool        STDMETHODCALLTYPE SetName(const char* a_pchName) = 0;
		///  
		virtual LPCSTR      STDMETHODCALLTYPE GetName() const = 0;

		///   .
		///     ,    
		///  .        .
		///     @ref TAGPROP_ENABLEFREQCORRECTION     
		virtual void        STDMETHODCALLTYPE SetFreq(double a_dblFreq) = 0;
		///<   
		virtual double      STDMETHODCALLTYPE GetFreq() = 0;
		
		///   
		virtual bool STDMETHODCALLTYPE Notify (DWORD dwCommand, DWORD dwParam) = 0;

		
		///   
		virtual bool STDMETHODCALLTYPE SetProperty(DWORD dwPropertyID, VARIANT a_Value) = 0;
		///   
		virtual bool STDMETHODCALLTYPE GetProperty(DWORD dwPropertyID, VARIANT& a_Value) = 0;

		
		/// @cond OBSOLETE

		///     ()
		virtual Signals::ISignal*  STDMETHODCALLTYPE GetData() = 0;


		///    ()
		virtual HRESULT    STDMETHODCALLTYPE SynchroReadDataBlock(
				double dblFreq, 
				DWORD dwPortionLen, 
				double* pdblBuffer,
				BOOL boolViaTransformer) = 0;
		/// @endcond
		
		/// C  (        )
		virtual bool     STDMETHODCALLTYPE isCfgWritable() = 0;

		///    (      )
		virtual bool     STDMETHODCALLTYPE CfgWritable(bool fNewState) = 0;

		/// @brief      
		/// @details     ,    
		///        
		/// @param pData -  raw-
		/// @param nCount -    ,   ,  - -1
		virtual bool     STDMETHODCALLTYPE PushData(void* pData, int nCount = -1) = 0;
		
		
		///      ( )
		virtual bool     STDMETHODCALLTYPE PushValue(double dValue, double dXValue=-1) = 0;

		///       
		virtual bool     STDMETHODCALLTYPE SetYRange(float a_fltRange) = 0;
		
		///       
		virtual float    STDMETHODCALLTYPE GetYRange() = 0;

		/// @brief       0.1%.
		/// @details       . 
		///      
		virtual bool     STDMETHODCALLTYPE SetYShift(float fltShift) = 0;
		
		/// @brief       0.1%.
		/// @details       
		///      		
		virtual float    STDMETHODCALLTYPE GetYShift() = 0;

		///    
		virtual HRESULT  STDMETHODCALLTYPE LinkGroup(ITagsGroup* a_pGroup) = 0;
		///     
		virtual HRESULT  STDMETHODCALLTYPE GetGroup(ITagsGroup** a_ppGroup) = 0;

		virtual VARTYPE  STDMETHODCALLTYPE GetDataType() = 0;

		///  
		virtual void     STDMETHODCALLTYPE SetEstimate(
					double dblValue, 
					ULONG nMask, 
					double dblDeviceTime = 0.0, 
					double dblUTSTime = 0.0) = 0;

		///  .
		///     .     .
		///      ,  
		/// @ref GetScalarEstimate  @ref GetScalarEstimateEx
		///   @ref GetScalarEstimateEx      
		///    
		virtual double   STDMETHODCALLTYPE GetEstimate(ULONG nEstimator) = 0;
		
		///    
		virtual HRESULT  STDMETHODCALLTYPE SetEstimatorsMask(ULONG a_nMask)=0;
		///    
		virtual ULONG    STDMETHODCALLTYPE GetEstimatorsMask()=0;

		///     
		virtual double   STDMETHODCALLTYPE Eval(double a_dblValue)=0;

		/// v1.06.2+
		///       
		virtual bool     STDMETHODCALLTYPE SetXRange(float a_fltRange)=0;
		///       
		virtual float    STDMETHODCALLTYPE GetXRange()=0;

		///       
		virtual bool     STDMETHODCALLTYPE SetXShift(float a_fltShift)=0;
		
		///       
		virtual float    STDMETHODCALLTYPE GetXShift()=0;
		///      rcTMI
		virtual int      STDMETHODCALLTYPE GetSize()=0;

		///    
		virtual DWORD    STDMETHODCALLTYPE GetScalarStatus() = 0;
		
		///    
		virtual void     STDMETHODCALLTYPE SetScalarStatus(DWORD dwStatus) = 0;

		///     
		/// @details 
		/// <br>.  <br> @ref GetScalarEstimateEx  @ref GetEstimate
		virtual HRESULT  STDMETHODCALLTYPE GetScalarEstimate(
				double &dblValue, 
				DWORD dwEstimator
			) = 0;
		
		///    
		virtual LPCSTR   STDMETHODCALLTYPE GetScalarEstimateInfo(
				DWORD dwEstimator, 
				DWORD dwInfoCode
			) = 0;

		///     ( )       
		virtual HRESULT  STDMETHODCALLTYPE PushDataEx(
				void* pData, 
				int nCount = -1,
				double dblTimeUTS = 0,
				double dblTimeInternal = 0
			) = 0;

		///    
		virtual HRESULT STDMETHODCALLTYPE SetPropertyEx(
				DWORD dwPropertyID, 
				VARIANT Value, 
				LONG lSubPropertyIndex, 
				DWORD dwReserved = 0
			) = 0;

		///    
		virtual HRESULT STDMETHODCALLTYPE GetPropertyEx(
				DWORD dwPropertyID, 
				VARIANT& Value, 
				LONG lSubPropertyIndex, 
				DWORD dwReserved = 0
			) = 0;

		/// @brief        
		/// @details since v2.0.6
		/// <br>.  <br> @ref GetScalarEstimate  @ref GetEstimate
		virtual HRESULT  STDMETHODCALLTYPE GetScalarEstimateEx(
				double& dblValue, 
				DWORD dwEstimator, 
				double* pdblDeviceTime = 0, 
				double* pdblUTSTime = 0
			) = 0;
		
		/// since v2.7.7.8
		///      
		virtual HRESULT  STDMETHODCALLTYPE GetLastEvalState(ULONG& state) const = 0;

		virtual HRESULT STDMETHODCALLTYPE Destroy() = 0;
		
		///    
		virtual HRESULT STDMETHODCALLTYPE GetTagId(TAGID* a_pId) const = 0;

};


// {F020021F-624A-4076-9DA4-4F45121E2C0B}
static const GUID IID_ITagBlockVectorControl = 
{ 0xf020021f, 0x624a, 0x4076, { 0x9d, 0xa4, 0x4f, 0x45, 0x12, 0x1e, 0x2c, 0xb } };


/// @interface ITagBlockVectorControl
///      
class ITagBlockVectorControl : public IUnknown
{
public:
	virtual HRESULT  STDMETHODCALLTYPE ConfigBlockVector(ULONG nBlockLen, ULONG nBlocksCounter) = 0;
};
#endif