/******************************************************************************/
/*  Recorder\iface                                                            */
/*                                                                            */
/*    IVForm                                                */
/*                                                  */
/*                                                                            */
/*                                                                            */
/*    : ivform.h                                              */
/*  : MVC++6.0                                                      */
/*                                                                            */
/*  (c)  "" 2001, 2002 .                                             */
/******************************************************************************/

#ifndef IVFORM_H
#define IVFORM_H
#include "itag.h"
#include "irecorder.h"
#include "rcplugin.h"



// {95001263-E83C-11d6-9243-00E029288A7F}
extern GUID IID_IVForm;


//    
// Visualization server notifications
enum{
	//    
	VSN_ENTERRCCONFIG = PN_ENTERRCCONFIG,             //     
	VSN_LEAVERCCONFIG = PN_LEAVERCCONFIG,             //     
	VSN_CHANGECURTAG  = PN_CHANGECURTAG,              //   , data=ITag*

	VSN_RCSAVECONFIG  = PN_RCSAVECONFIG,              //   
	VSN_RCLOADCONFIG  = PN_RCLOADCONFIG,              //   

	VSN_RCSTART       = PN_RCSTART,                   //     / 
	VSN_RCPLAY        = PN_RCPLAY,                    //      
	VSN_RCSTOP        = PN_RCSTOP,                    //  
	VSN_BEFORE_RCSTART= PN_BEFORE_RCSTART,            //     / 
	VSN_BEFORE_RCSTOP = PN_BEFORE_RCSTOP ,            //  
	VSN_ABORT_RCSTART = PN_ABORT_RCSTART,             //    
	VSN_UPDATE_DATA   = PN_UPDATEDATA,		            //    rc

	//  
	VSN_SPECIFIED = 0x4000,     //
	VSN_RESIZE,                 //    
	VSN_CHANGEVIEWTIME,         //   
	VSN_CHANGETIMESHIFT,        //    
	VSN_CHANGERCSTATE,          //   Recorder  dwData  
	VSN_SET_PARENT,             //    (dwData)
	VSN_QUERY_ALARMS_STATE,     //   
	VSN_QUERY_ALARMS_COLOR,     //    
	VSN_GET_TRANSPARENT,        //   
	VSN_ON_CHANGE_TAGS_FILTER,  //   
	VSN_ON_DBLCLK_TAGS_LIST,    //        
	VSN_ON_ADD_SELECTED_TAGS,   //     ,      
	VSN_QUERY_DROP_ACCEPT,      //   DnD 
	VSN_USER = 0x7000           //   VFN_USER+XXXX

};

///      
///   <br>
/// wParam   IVForm <br>
/// lParam   <br>
///    lParam    MAKELPARAM(x,y)<br>
///       
/// RegisterWindowMessage
#define ID_WM_ON_CHANGE_CHILD_SIZE "Mera.Recorder.IVForm.WM_ON_CHANGE_CHILD_SIZE"



class IVForm: public IUnknown
{
public:
	//     ,   
	virtual LPCSTR      STDMETHODCALLTYPE getname() = 0;
	// 
	virtual bool        STDMETHODCALLTYPE init(
			IRecorder* a_pParent, 
			HWND a_hParent, 
			long int a_lParam
		) = 0;
	// HWND 
	virtual HWND        STDMETHODCALLTYPE getHWND() = 0;
	//   
	virtual bool        STDMETHODCALLTYPE close() = 0;
	virtual bool        STDMETHODCALLTYPE prepare() = 0;
	virtual bool        STDMETHODCALLTYPE update() = 0;
	// 
	virtual bool        STDMETHODCALLTYPE repaint() = 0;
	//   
	virtual bool        STDMETHODCALLTYPE linktags(ITag** pTagsList, ULONG nTagsCount) = 0;
	// 
	virtual bool        STDMETHODCALLTYPE activate() = 0;
	// 
	virtual bool        STDMETHODCALLTYPE deactivate() = 0;
	//  
	virtual bool        STDMETHODCALLTYPE edit() = 0;

	//, , 
	virtual bool        STDMETHODCALLTYPE notify(DWORD dwCommand, DWORD dwData = 0) = 0;

};
#endif
