#ifndef ITARGET_H
#define ITARGET_H

// {1D26DB81-023F-11d7-9243-00E029288A7F}
static const GUID IID_ITarget = 
{ 0x1d26db81, 0x23f, 0x11d7, { 0x92, 0x43, 0x0, 0xe0, 0x29, 0x28, 0x8a, 0x7f } };


#include "itag.h"

class ITarget: public IUnknown
{
  public:
    virtual HRESULT       STDMETHODCALLTYPE Create()PURE;
    virtual HRESULT       STDMETHODCALLTYPE Config(DWORD a_dwParam=0)PURE;
    virtual HRESULT       STDMETHODCALLTYPE SetPortionSize(DWORD a_dwPortionSize)PURE;
    virtual HRESULT       STDMETHODCALLTYPE Prepare()PURE;
    virtual HRESULT       STDMETHODCALLTYPE Start()PURE;
    virtual HRESULT       STDMETHODCALLTYPE Exec(void* a_pData, DWORD a_dwStatus=0)PURE;
    virtual HRESULT       STDMETHODCALLTYPE Reset()PURE;
    virtual HRESULT       STDMETHODCALLTYPE Finish()PURE;
    virtual HRESULT       STDMETHODCALLTYPE Flush()PURE;
    virtual HRESULT       STDMETHODCALLTYPE Stop()PURE;
    virtual HRESULT       STDMETHODCALLTYPE Destroy()PURE;


    virtual HRESULT       STDMETHODCALLTYPE Enable()PURE;
    virtual HRESULT       STDMETHODCALLTYPE Disable()PURE;
    virtual BOOL          STDMETHODCALLTYPE isEnabled()PURE;
    virtual TARGETTYPE    STDMETHODCALLTYPE GetType()PURE;
    virtual LPCSTR        STDMETHODCALLTYPE GetName()PURE;
    virtual HRESULT       STDMETHODCALLTYPE Edit()PURE;
    virtual void*         STDMETHODCALLTYPE GetEditor()PURE;
    virtual HRESULT       STDMETHODCALLTYPE LinkOwner(ITag* a_pOwner)PURE;

    //    
    virtual HRESULT       STDMETHODCALLTYPE Notify(DWORD a_dwCommand, DWORD a_dwParam = 0)PURE;
    //  
    virtual HRESULT       STDMETHODCALLTYPE GetProperty(DWORD a_dwPropertyID, VARIANT& a_Value)PURE;
    //  
    virtual HRESULT       STDMETHODCALLTYPE SetProperty(DWORD a_dwPropertyID, VARIANT a_Value)PURE;

};

#endif